From 552f7bddd65f8d4047646ad9b891cdfd7c5edf60 Mon Sep 17 00:00:00 2001
From: z00347042 <zhuqi1@huawei.com>
Date: Thu, 11 Jun 2020 15:51:20 +0800
Subject: [PATCH] =?UTF-8?q?ARM=20TRX=5FSYS=20Hash=20Table=E5=8E=BB?=
 =?UTF-8?q?=E9=94=81=E4=BC=98=E5=8C=96?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 CMakeLists.txt                                     |   1 +
 configure.cmake                                    |   1 -
 include/lf.h                                       |   7 +
 mysql-test/include/have_lock_free_readview.inc     |   6 +
 mysql-test/include/no_lock_free_readview.inc       |   6 +
 ...innodb_i_s_innodb_trx_lock_free_readview.result |  81 ++
 .../suite/innodb/t/innodb_i_s_innodb_trx.test      |   2 +
 .../innodb_i_s_innodb_trx_lock_free_readview.test  | 103 +++
 mysys/lf_hash.cc                                   | 161 ++++
 storage/innobase/api/api0api.cc                    |   8 +
 storage/innobase/buf/buf0buf.cc                    |  21 +
 storage/innobase/clone/clone0copy.cc               |   8 +
 storage/innobase/clone/clone0repl.cc               |   2 +
 storage/innobase/dict/dict0dd.cc                   |   6 +
 storage/innobase/dict/dict0mem.cc                  |   5 +
 storage/innobase/handler/ha_innodb.cc              |  56 +-
 storage/innobase/handler/ha_innopart.cc            |   8 +
 storage/innobase/handler/handler0alter.cc          |  12 +
 storage/innobase/handler/p_s.cc                    | 142 ++++
 storage/innobase/include/clone0repl.h              |   4 +
 storage/innobase/include/read0read.h               |   3 +
 storage/innobase/include/read0types.h              |  92 +++
 storage/innobase/include/row0vers.h                |   6 +
 storage/innobase/include/srv0srv.h                 |   3 +
 storage/innobase/include/sync0sync.h               |   3 +
 storage/innobase/include/sync0types.h              |   6 +
 storage/innobase/include/trx0roll.h                |  10 +
 storage/innobase/include/trx0sys.h                 | 518 +++++++++++++
 storage/innobase/include/trx0sys.ic                |   2 +
 storage/innobase/include/trx0trx.h                 | 199 ++++-
 storage/innobase/include/trx0trx.ic                |  20 +
 storage/innobase/include/trx0types.h               |   2 +
 storage/innobase/include/trx0undo.h                |   5 +
 storage/innobase/include/ut0counter.h              |   2 +-
 storage/innobase/include/ut0new.h                  |   2 +
 storage/innobase/lock/lock0lock.cc                 | 471 ++++++++++++
 storage/innobase/page/page0page.cc                 |   4 +
 storage/innobase/read/read0read.cc                 | 132 ++++
 storage/innobase/row/row0ins.cc                    |   4 +
 storage/innobase/row/row0merge.cc                  |  19 +
 storage/innobase/row/row0mysql.cc                  |   4 +
 storage/innobase/row/row0pread.cc                  |   7 +
 storage/innobase/row/row0row.cc                    |   7 +
 storage/innobase/row/row0sel.cc                    |  66 +-
 storage/innobase/row/row0upd.cc                    |   6 +
 storage/innobase/row/row0vers.cc                   |  61 +-
 storage/innobase/srv/srv0srv.cc                    |  17 +
 storage/innobase/srv/srv0start.cc                  |  36 +
 storage/innobase/sync/sync0debug.cc                |  14 +
 storage/innobase/sync/sync0sync.cc                 |   3 +
 storage/innobase/trx/trx0i_s.cc                    |  44 ++
 storage/innobase/trx/trx0purge.cc                  |  20 +
 storage/innobase/trx/trx0roll.cc                   | 104 +++
 storage/innobase/trx/trx0sys.cc                    | 581 ++++++++++++++-
 storage/innobase/trx/trx0trx.cc                    | 827 ++++++++++++++++++++-
 storage/innobase/trx/trx0undo.cc                   |  66 ++
 storage/innobase/ut/ut0new.cc                      |   4 +
 unittest/gunit/mysys_lf-t.cc                       |  17 +
 58 files changed, 4011 insertions(+), 16 deletions(-)
 create mode 100644 mysql-test/include/have_lock_free_readview.inc
 create mode 100644 mysql-test/include/no_lock_free_readview.inc
 create mode 100644 mysql-test/suite/innodb/r/innodb_i_s_innodb_trx_lock_free_readview.result
 create mode 100644 mysql-test/suite/innodb/t/innodb_i_s_innodb_trx_lock_free_readview.test

diff --git a/CMakeLists.txt b/CMakeLists.txt
index ce1d1bb..b450a81 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -1031,6 +1031,7 @@ ADD_DEFINITIONS(-D__STDC_LIMIT_MACROS)     # Enable C99 limit macros
 ADD_DEFINITIONS(-D__STDC_FORMAT_MACROS)    # Enable C99 printf format macros
 ADD_DEFINITIONS(-D_USE_MATH_DEFINES)       # Get access to M_PI, M_E, etc. in math.h
 ADD_DEFINITIONS(-DLZ4_DISABLE_DEPRECATE_WARNINGS) # C++14 deprecation warnings in LZ4.
+ADD_DEFINITIONS(-DHAVE_LOCK_FREE_READVIEW) # Enable lock free readview feature
 
 OPTION(ENABLE_EXPERIMENT_SYSVARS "Expose ussually hidden system variables to allow experiments" OFF)
 IF(ENABLE_EXPERIMENT_SYSVARS)
diff --git a/include/lf.h b/include/lf.h
index 53898f4..6e25ec6 100644
--- a/include/lf.h
+++ b/include/lf.h
@@ -159,6 +159,9 @@ struct LF_HASH;
 
 typedef uint lf_hash_func(const LF_HASH *, const uchar *, size_t);
 typedef void lf_hash_init_func(uchar *dst, const uchar *src);
+#ifdef HAVE_LOCK_FREE_READVIEW
+typedef bool lf_hash_walk_func(void *, void *);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 #define LF_HASH_UNIQUE 1
 #define MY_LF_ERRPTR ((void *)(intptr)1)
@@ -214,6 +217,10 @@ int lf_hash_insert(LF_HASH *hash, LF_PINS *pins, const void *data);
 void *lf_hash_search(LF_HASH *hash, LF_PINS *pins, const void *key,
                      uint keylen);
 int lf_hash_delete(LF_HASH *hash, LF_PINS *pins, const void *key, uint keylen);
+#ifdef HAVE_LOCK_FREE_READVIEW
+int lf_hash_iterate(LF_HASH *hash, LF_PINS *pins, const lf_hash_walk_func *callback,
+                    const void *argument);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 static inline LF_PINS *lf_hash_get_pins(LF_HASH *hash) {
   return lf_pinbox_get_pins(&hash->alloc.pinbox);
diff --git a/mysql-test/include/have_lock_free_readview.inc b/mysql-test/include/have_lock_free_readview.inc
new file mode 100644
index 0000000..a24932e
--- /dev/null
+++ b/mysql-test/include/have_lock_free_readview.inc
@@ -0,0 +1,6 @@
+--let $_have_lock_free_readview = `select VARIABLE_VALUE from performance_schema.global_status where VARIABLE_NAME = 'Innodb_have_lock_free_readview';`
+
+if ($_have_lock_free_readview == "")
+{
+  --skip Need lock free readview binaries
+}
diff --git a/mysql-test/include/no_lock_free_readview.inc b/mysql-test/include/no_lock_free_readview.inc
new file mode 100644
index 0000000..779d9eb
--- /dev/null
+++ b/mysql-test/include/no_lock_free_readview.inc
@@ -0,0 +1,6 @@
+--let $_have_lock_free_readview = `select VARIABLE_VALUE from performance_schema.global_status where VARIABLE_NAME = 'Innodb_have_lock_free_readview';`
+
+if ($_have_lock_free_readview == "ON")
+{
+  --skip Doesn't support lock free readview binaries
+}
diff --git a/mysql-test/suite/innodb/r/innodb_i_s_innodb_trx_lock_free_readview.result b/mysql-test/suite/innodb/r/innodb_i_s_innodb_trx_lock_free_readview.result
new file mode 100644
index 0000000..73e742c
--- /dev/null
+++ b/mysql-test/suite/innodb/r/innodb_i_s_innodb_trx_lock_free_readview.result
@@ -0,0 +1,81 @@
+SET GLOBAL innodb_lock_wait_timeout=600;
+DESCRIBE INFORMATION_SCHEMA.INNODB_TRX;
+Field	Type	Null	Key	Default	Extra
+trx_id	varchar(18)	NO			
+trx_state	varchar(13)	NO			
+trx_started	datetime	NO			
+trx_requested_lock_id	varchar(105)	YES			
+trx_wait_started	datetime	YES			
+trx_weight	bigint unsigned	NO			
+trx_mysql_thread_id	bigint unsigned	NO			
+trx_query	varchar(1024)	YES			
+trx_operation_state	varchar(64)	YES			
+trx_tables_in_use	bigint unsigned	NO			
+trx_tables_locked	bigint unsigned	NO			
+trx_lock_structs	bigint unsigned	NO			
+trx_lock_memory_bytes	bigint unsigned	NO			
+trx_rows_locked	bigint unsigned	NO			
+trx_rows_modified	bigint unsigned	NO			
+trx_concurrency_tickets	bigint unsigned	NO			
+trx_isolation_level	varchar(16)	NO			
+trx_unique_checks	int	NO			
+trx_foreign_key_checks	int	NO			
+trx_last_foreign_key_error	varchar(256)	YES			
+trx_adaptive_hash_latched	int	NO			
+trx_adaptive_hash_timeout	bigint unsigned	NO			
+trx_is_read_only	int	NO			
+trx_autocommit_non_locking	int	NO			
+DROP TABLE IF EXISTS t1;
+CREATE TABLE t1 (
+c01 INT,
+c02 INT,
+PRIMARY KEY (c01)
+) ENGINE=INNODB STATS_AUTO_RECALC=0;
+INSERT INTO t1 VALUES
+(1,2),(2,4),(3,6),(4,8);
+CREATE TABLE t2 (
+c01 INT,
+c02 INT,
+PRIMARY KEY (c01),
+CONSTRAINT fk1 FOREIGN KEY (c02) REFERENCES t1 (c01)
+) ENGINE=INNODB STATS_AUTO_RECALC=0;
+INSERT INTO t2 VALUES
+(1,1),(2,2),(3,3);
+SET autocommit=0;
+INSERT INTO t1 VALUES (5,10);
+SELECT * FROM t1 FOR UPDATE;
+c01	c02
+1	2
+2	4
+3	6
+4	8
+5	10
+SELECT trx_state, trx_weight, trx_tables_in_use, trx_tables_locked,
+trx_rows_locked, trx_rows_modified, trx_concurrency_tickets,
+trx_isolation_level, trx_unique_checks, trx_foreign_key_checks
+FROM INFORMATION_SCHEMA.INNODB_TRX;
+trx_state	trx_weight	trx_tables_in_use	trx_tables_locked	trx_rows_locked	trx_rows_modified	trx_concurrency_tickets	trx_isolation_level	trx_unique_checks	trx_foreign_key_checks
+RUNNING	3	0	1	5	1	0	REPEATABLE READ	1	1
+ROLLBACK;
+SET FOREIGN_KEY_CHECKS = 0;
+SET UNIQUE_CHECKS = 0;
+SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
+BEGIN;
+INSERT INTO t1 VALUES (6,12);
+SELECT trx_isolation_level, trx_unique_checks, trx_foreign_key_checks
+FROM INFORMATION_SCHEMA.INNODB_TRX;
+trx_isolation_level	trx_unique_checks	trx_foreign_key_checks
+SERIALIZABLE	0	0
+ROLLBACK;
+SET FOREIGN_KEY_CHECKS = 1;
+SET UNIQUE_CHECKS = 1;
+BEGIN;
+INSERT INTO t2 VALUES (4,10);
+ERROR 23000: Cannot add or update a child row: a foreign key constraint fails (`test`.`t2`, CONSTRAINT `fk1` FOREIGN KEY (`c02`) REFERENCES `t1` (`c01`))
+SELECT trx_state, trx_isolation_level, trx_last_foreign_key_error
+FROM INFORMATION_SCHEMA.INNODB_TRX;
+trx_state	trx_isolation_level	trx_last_foreign_key_error
+RUNNING	REPEATABLE READ	`test`.`t2`, CONSTRAINT `fk1` FOREIGN KEY (`c02`) REFERENCES `t1` (`c01`)
+DROP TABLE t2;
+DROP TABLE t1;
+SET GLOBAL innodb_lock_wait_timeout=default;
diff --git a/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx.test b/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx.test
index b92cc8f..1fbc71f 100644
--- a/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx.test
+++ b/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx.test
@@ -6,6 +6,8 @@
 
 # Make sure the locks keep waiting until they are released,
 # even on a busy system.
+--source include/no_lock_free_readview.inc
+
 SET GLOBAL innodb_lock_wait_timeout=600;
 
 DESCRIBE INFORMATION_SCHEMA.INNODB_TRX;
diff --git a/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx_lock_free_readview.test b/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx_lock_free_readview.test
new file mode 100644
index 0000000..7cc3709
--- /dev/null
+++ b/mysql-test/suite/innodb/t/innodb_i_s_innodb_trx_lock_free_readview.test
@@ -0,0 +1,103 @@
+
+#
+# Test that transaction data is correctly "visualized" in
+# INFORMATION_SCHEMA.INNODB_TRX
+#
+
+# Make sure the locks keep waiting until they are released,
+# even on a busy system.
+--source include/have_lock_free_readview.inc
+
+SET GLOBAL innodb_lock_wait_timeout=600;
+
+DESCRIBE INFORMATION_SCHEMA.INNODB_TRX;
+
+-- disable_warnings
+DROP TABLE IF EXISTS t1;
+-- enable_warnings
+
+CREATE TABLE t1 (
+	c01 INT,
+	c02 INT,
+	PRIMARY KEY (c01)
+) ENGINE=INNODB STATS_AUTO_RECALC=0;
+
+INSERT INTO t1 VALUES
+(1,2),(2,4),(3,6),(4,8);
+
+CREATE TABLE t2 (
+	c01 INT,
+	c02 INT,
+	PRIMARY KEY (c01),
+	CONSTRAINT fk1 FOREIGN KEY (c02) REFERENCES t1 (c01)
+) ENGINE=INNODB STATS_AUTO_RECALC=0;
+
+INSERT INTO t2 VALUES
+(1,1),(2,2),(3,3);
+
+-- source include/count_sessions.inc
+
+-- connect (con_trx,localhost,root,,)
+-- connect (con_verify_innodb_trx,localhost,root,,)
+
+-- connection con_trx
+SET autocommit=0;
+INSERT INTO t1 VALUES (5,10);
+SELECT * FROM t1 FOR UPDATE;
+
+let $wait_timeout= 300;
+let $wait_condition=
+  SELECT COUNT(*) = 1 FROM INFORMATION_SCHEMA.INNODB_TRX;
+-- source include/wait_condition.inc
+
+-- connection con_verify_innodb_trx
+SELECT trx_state, trx_weight, trx_tables_in_use, trx_tables_locked,
+trx_rows_locked, trx_rows_modified, trx_concurrency_tickets,
+trx_isolation_level, trx_unique_checks, trx_foreign_key_checks
+FROM INFORMATION_SCHEMA.INNODB_TRX;
+
+-- connection con_trx
+ROLLBACK;
+SET FOREIGN_KEY_CHECKS = 0;
+SET UNIQUE_CHECKS = 0;
+SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
+BEGIN;
+INSERT INTO t1 VALUES (6,12);
+
+let $wait_timeout= 300;
+let $wait_condition=
+  SELECT trx_unique_checks = 0 FROM INFORMATION_SCHEMA.INNODB_TRX;
+-- source include/wait_condition.inc
+
+-- connection con_verify_innodb_trx
+SELECT trx_isolation_level, trx_unique_checks, trx_foreign_key_checks
+FROM INFORMATION_SCHEMA.INNODB_TRX;
+
+-- connection con_trx
+ROLLBACK;
+SET FOREIGN_KEY_CHECKS = 1;
+SET UNIQUE_CHECKS = 1;
+BEGIN;
+-- error 1452
+INSERT INTO t2 VALUES (4,10);
+
+let $wait_timeout= 300;
+let $wait_condition=
+  SELECT trx_unique_checks  = 1 FROM INFORMATION_SCHEMA.INNODB_TRX;
+-- source include/wait_condition.inc
+
+-- connection con_verify_innodb_trx
+SELECT trx_state, trx_isolation_level, trx_last_foreign_key_error
+FROM INFORMATION_SCHEMA.INNODB_TRX;
+
+-- connection default
+
+-- disconnect con_trx
+-- disconnect con_verify_innodb_trx
+
+DROP TABLE t2;
+DROP TABLE t1;
+
+-- source include/wait_until_count_sessions.inc
+
+SET GLOBAL innodb_lock_wait_timeout=default;
diff --git a/mysys/lf_hash.cc b/mysys/lf_hash.cc
index cf0cffa..e6f8ec7 100644
--- a/mysys/lf_hash.cc
+++ b/mysys/lf_hash.cc
@@ -101,6 +101,126 @@ static inline T *SET_DELETED(T *ptr) {
   return reinterpret_cast<T *>(i);
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/**
+  Walk the list, searching for an element or invoking a callback.
+
+  Search for hashnr/key/keylen in the list starting from 'head' and position the
+  cursor. The list is ORDER by hashnr, key
+
+  @param head         start walking the list from this node
+  @param cs           charset for comparing keys, nullptr if callback is used
+  @param hashnr       hash number to searching for
+  @param key          key to search for OR data for the callback
+  @param keylen       length of the key to compare, 0 if callback is used
+  @param cursor       for returning the found element
+  @param pins         see lf_alloc-pin.cc
+  @param callback     callback action, invoked for every element
+
+  @note
+    cursor is positioned in either case
+    pins[0..2] are used, they are not removed on return
+    callback might see some elements twice (because of retries)
+
+  @return
+    if find: 0 - not found
+             1 - found
+    if callback:
+             0 - ok
+             1 - error (callback returned true)
+*/
+static int my_lfind(std::atomic<LF_SLIST *> *head, CHARSET_INFO *cs,
+                    uint32 hashnr, const uchar *key, size_t keylen,
+                    CURSOR *cursor, LF_PINS *pins,
+                    lf_hash_walk_func *callback) {
+  uint32 cur_hashnr;
+  const uchar *cur_key;
+  size_t cur_keylen;
+  LF_SLIST *link;
+
+  /* should not be set both */
+  DBUG_ASSERT((cs == nullptr) || (callback == nullptr));
+  /* should not be set both */
+  DBUG_ASSERT((keylen == 0) || (callback == nullptr));
+
+retry:
+  cursor->prev = head;
+  do /* PTR() isn't necessary below, head is a dummy node */
+  {
+    cursor->curr = (LF_SLIST *)(*cursor->prev);
+    lf_pin(pins, 1, cursor->curr);
+  } while (*cursor->prev != cursor->curr && LF_BACKOFF);
+  for (;;) {
+
+    if (unlikely(!cursor->curr)) {
+      return 0; /* end of the list */
+    }
+
+    cur_hashnr = cursor->curr->hashnr;
+    cur_keylen = cursor->curr->keylen;
+    cur_key = cursor->curr->key;
+
+    do {
+      link = cursor->curr->link;
+      cursor->next = PTR(link);
+      lf_pin(pins, 0, cursor->next);
+    } while (link != cursor->curr->link && LF_BACKOFF);
+
+    if (!DELETED(link)) {
+      if (likely(callback != nullptr)) {
+        if ((cur_hashnr & 1) > 0 &&
+            callback(cursor->curr + 1,
+                     const_cast<void *>(static_cast<const void *>(key)))) {
+          return 1;
+        }
+      } else if (cur_hashnr >= hashnr) {
+        int r = 1;
+        if (cur_hashnr > hashnr ||
+            (r = my_strnncoll(cs, cur_key, cur_keylen, key, keylen)) >= 0) {
+          return !r;
+        }
+      }
+      cursor->prev = &(cursor->curr->link);
+      if (!(cur_hashnr & 1)) /* dummy node */
+        head = cursor->prev;
+      lf_pin(pins, 2, cursor->curr);
+    } else {
+      /*
+        we found a deleted node - be nice, help the other thread
+        and remove this deleted node
+      */
+      if (atomic_compare_exchange_strong(cursor->prev, &cursor->curr,
+                                         cursor->next)) {
+        lf_pinbox_free(pins, cursor->curr);
+      } else {
+        (void)LF_BACKOFF;
+        goto retry;
+      }
+    }
+    cursor->curr = cursor->next;
+    lf_pin(pins, 1, cursor->curr);
+  }
+}
+
+/*
+  DESCRIPTION
+    Search for hashnr/key/keylen in the list starting from 'head' and
+    position the cursor. The list is ORDER BY hashnr, key
+
+  RETURN
+    0 - not found
+    1 - found
+
+  NOTE
+    cursor is positioned in either case
+    pins[0..2] are used, they are NOT removed on return
+*/
+static int my_lfind(std::atomic<LF_SLIST *> *head, CHARSET_INFO *cs,
+                    uint32 hashnr, const uchar *key, size_t keylen,
+                    CURSOR *cursor, LF_PINS *pins) {
+  return my_lfind(head, cs, hashnr, key, keylen, cursor, pins, nullptr);
+}
+#else
 /*
   DESCRIPTION
     Search for hashnr/key/keylen in the list starting from 'head' and
@@ -173,6 +293,7 @@ retry:
     lf_pin(pins, 1, cursor->curr);
   }
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /**
   Search for list element satisfying condition specified by match
@@ -570,6 +691,46 @@ int lf_hash_delete(LF_HASH *hash, LF_PINS *pins, const void *key, uint keylen) {
   return 0;
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/**
+  Iterate over all elements in hash and call function with the element.
+
+  @note
+  If one of 'callback' invocations returns true the iteration aborts.
+  'action' might see some elements twice!
+
+  @return 0 if ok, or 1 if error (action returned true)
+*/
+int lf_hash_iterate(LF_HASH *hash, LF_PINS *pins, const lf_hash_walk_func *callback,
+                    const void *argument) {
+  CURSOR cursor;
+  uint bucket = 0;
+  int res;
+  std::atomic<LF_SLIST *> *el;
+
+  el = static_cast<std::atomic<LF_SLIST *> *>(
+      lf_dynarray_lvalue(&hash->array, bucket));
+  if (unlikely(el == nullptr)) {
+    /* if there's no bucket==0, the hash is empty */
+    return 0;
+  }
+
+  if (*el == nullptr && unlikely(initialize_bucket(hash, el, bucket, pins))) {
+    /* if there's no bucket==0, the hash is empty */
+    return 0;
+  }
+
+  res = my_lfind(el, nullptr, 0, static_cast<const uchar *>(argument), 0, &cursor,
+                 pins, callback);
+
+  lf_unpin(pins, 2);
+  lf_unpin(pins, 1);
+  lf_unpin(pins, 0);
+
+  return res;
+}
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
 /**
   Find hash element corresponding to the key.
 
diff --git a/storage/innobase/api/api0api.cc b/storage/innobase/api/api0api.cc
index 044ee0b..51c0a41 100644
--- a/storage/innobase/api/api0api.cc
+++ b/storage/innobase/api/api0api.cc
@@ -743,7 +743,11 @@ static ib_err_t ib_create_cursor(ib_crsr_t *ib_crsr,  /*!< out: InnoDB cursor */
       /* Assign a read view if the transaction does
       not have it yet */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+      prebuilt->trx->read_view.open(prebuilt->trx);
+#else
       trx_assign_read_view(prebuilt->trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     }
 
     *ib_crsr = (ib_crsr_t)cursor;
@@ -934,7 +938,11 @@ ib_err_t ib_cursor_new_trx(ib_crsr_t ib_crsr, /*!< in/out: InnoDB cursor */
 
   cursor->valid_trx = TRUE;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  prebuilt->trx->read_view.open(prebuilt->trx);
+#else
   trx_assign_read_view(prebuilt->trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   ib_qry_proc_free(&cursor->q_proc);
 
diff --git a/storage/innobase/buf/buf0buf.cc b/storage/innobase/buf/buf0buf.cc
index 983603e..f3191db 100644
--- a/storage/innobase/buf/buf0buf.cc
+++ b/storage/innobase/buf/buf0buf.cc
@@ -2143,6 +2143,26 @@ withdraw_retry:
 
     lock_mutex_enter();
     trx_sys_mutex_enter();
+#ifdef HAVE_LOCK_FREE_READVIEW
+    bool found = false;
+    for (trx_t *trx = UT_LIST_GET_FIRST(trx_sys->trx_list); trx != nullptr;
+         trx = UT_LIST_GET_NEXT(trx_list, trx)) {
+      if (trx->state != TRX_STATE_NOT_STARTED && trx->mysql_thd != nullptr &&
+          ut_difftime(withdraw_started, trx->start_time) > 0) {
+        if (!found) {
+          ib::warn(ER_IB_MSG_61) << "The following trx might hold"
+                                    " the blocks in buffer pool to"
+                                    " be withdrawn. Buffer pool"
+                                    " resizing can complete only"
+                                    " after all the transactions"
+                                    " below release the blocks.";
+          found = true;
+        }
+
+        lock_trx_print_wait_and_mvcc_state(stderr, trx);
+      }
+    }
+#else
     bool found = false;
     for (trx_t *trx = UT_LIST_GET_FIRST(trx_sys->mysql_trx_list); trx != NULL;
          trx = UT_LIST_GET_NEXT(mysql_trx_list, trx)) {
@@ -2161,6 +2181,7 @@ withdraw_retry:
         lock_trx_print_wait_and_mvcc_state(stderr, trx);
       }
     }
+#endif /* HAVE_LOCK_FREE_READVIEW */
     trx_sys_mutex_exit();
     lock_mutex_exit();
 
diff --git a/storage/innobase/clone/clone0copy.cc b/storage/innobase/clone/clone0copy.cc
index b18c8b4..4dc0092 100644
--- a/storage/innobase/clone/clone0copy.cc
+++ b/storage/innobase/clone/clone0copy.cc
@@ -327,14 +327,22 @@ int Clone_Snapshot::update_binlog_position() {
 }
 
 int Clone_Snapshot::wait_trx_end(THD *thd, trx_id_t trx_id) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+  auto trx = trx_sys->find(current_trx(), trx_id, false);
+#else
   auto trx = trx_rw_is_active(trx_id, nullptr, false);
+#endif
   if (trx == nullptr) {
     return (0);
   }
 
   auto wait_cond = [&](bool alert, bool &result) {
     /* Check if transaction is still active. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+    auto trx = trx_sys->find(current_trx(), trx_id, false);
+#else
     auto trx = trx_rw_is_active(trx_id, nullptr, false);
+#endif
     if (trx == nullptr) {
       result = false;
       return (0);
diff --git a/storage/innobase/clone/clone0repl.cc b/storage/innobase/clone/clone0repl.cc
index 8b9484c..61928e5 100644
--- a/storage/innobase/clone/clone0repl.cc
+++ b/storage/innobase/clone/clone0repl.cc
@@ -49,7 +49,9 @@ void Clone_persist_gtid::add(const Gtid_desc &gtid_desc) {
   if (!is_active() || gtid_table_persistor == nullptr) {
     return;
   }
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif
   /* Get active GTID list */
   auto &current_gtids = get_active_list();
 
diff --git a/storage/innobase/dict/dict0dd.cc b/storage/innobase/dict/dict0dd.cc
index 01631fd..df40c27 100644
--- a/storage/innobase/dict/dict0dd.cc
+++ b/storage/innobase/dict/dict0dd.cc
@@ -6009,9 +6009,15 @@ the dictionary.
 bool dd_tablespace_update_cache(THD *thd) {
   /* If there are no prepared trxs, then DD reads would have been
   already consistent. No need to update cache */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (!trx_sys->found_prepared_trx()) {
+    return (false);
+  }
+#else
   if (!trx_sys->found_prepared_trx) {
     return (false);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   dd::cache::Dictionary_client *dc = dd::get_dd_client(thd);
   dd::cache::Dictionary_client::Auto_releaser releaser(dc);
diff --git a/storage/innobase/dict/dict0mem.cc b/storage/innobase/dict/dict0mem.cc
index 02bccdc..8e715e2 100644
--- a/storage/innobase/dict/dict0mem.cc
+++ b/storage/innobase/dict/dict0mem.cc
@@ -596,9 +596,14 @@ bool dict_index_t::is_usable(const trx_t *trx) const {
   }
 
   /* Check if the specified transaction can see this index. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  return (table->is_temporary() || trx_id == 0 || !trx->read_view.is_open() ||
+          trx->read_view.changes_visible(trx_id, table->name));
+#else
   return (table->is_temporary() || trx_id == 0 ||
           !MVCC::is_view_active(trx->read_view) ||
           trx->read_view->changes_visible(trx_id, table->name));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 #endif /* !UNIV_HOTBACKUP */
 
diff --git a/storage/innobase/handler/ha_innodb.cc b/storage/innobase/handler/ha_innodb.cc
index 75c2b84..9592b5a 100644
--- a/storage/innobase/handler/ha_innodb.cc
+++ b/storage/innobase/handler/ha_innodb.cc
@@ -671,6 +671,9 @@ static PSI_mutex_info all_innodb_mutexes[] = {
     PSI_MUTEX_KEY(rtr_match_mutex, 0, 0, PSI_DOCUMENT_ME),
     PSI_MUTEX_KEY(rtr_path_mutex, 0, 0, PSI_DOCUMENT_ME),
     PSI_MUTEX_KEY(rtr_ssn_mutex, 0, 0, PSI_DOCUMENT_ME),
+#ifdef HAVE_LOCK_FREE_READVIEW
+    PSI_MUTEX_KEY(rw_trx_hash_element_mutex, 0, 0, PSI_DOCUMENT_ME),
+#endif /* HAVE_LOCK_FREE_READVIEW */
     PSI_MUTEX_KEY(trx_sys_mutex, 0, 0, PSI_DOCUMENT_ME),
     PSI_MUTEX_KEY(zip_pad_mutex, 0, 0, PSI_DOCUMENT_ME),
     PSI_MUTEX_KEY(master_key_id_mutex, 0, 0, PSI_DOCUMENT_ME),
@@ -1059,6 +1062,11 @@ static SHOW_VAR innodb_status_variables[] = {
     {"undo_tablespaces_active",
      (char *)&export_vars.innodb_undo_tablespaces_active, SHOW_LONG,
      SHOW_SCOPE_GLOBAL},
+#ifdef HAVE_LOCK_FREE_READVIEW
+     {"have_lock_free_readview",
+     (char *)&export_vars.innodb_have_lock_free_readview, SHOW_BOOL,
+     SHOW_SCOPE_GLOBAL},
+#endif
 #ifdef UNIV_DEBUG
     {"purge_trx_id_age", (char *)&export_vars.innodb_purge_trx_id_age,
      SHOW_LONG, SHOW_SCOPE_GLOBAL},
@@ -2865,6 +2873,20 @@ ibool trx_is_strict(trx_t *trx) /*!< in: transaction */
           (!trx->in_truncate));
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** Gets current trx.
+
+ This function may be called during InnoDB initialisation, when
+ innodb_hton_ptr->slot is not yet set to meaningful value. */
+trx_t *current_trx() {
+  THD *thd = current_thd;
+  if (UNIV_LIKELY(thd != nullptr) && innodb_hton_ptr->slot != HA_SLOT_UNDEF) {
+    return thd_to_trx(thd);
+  }
+  return nullptr;
+}
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
 /** Resets some fields of a m_prebuilt struct. The template is used in fast
  retrieval of just those column values MySQL needs in its processing. */
 void ha_innobase::reset_template(void) {
@@ -2918,7 +2940,11 @@ void ha_innobase::init_table_handle_for_HANDLER(void) {
 
   /* Assign a read view if the transaction does not have it yet */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  m_prebuilt->trx->read_view.open(m_prebuilt->trx);
+#else
   trx_assign_read_view(m_prebuilt->trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   innobase_register_trx(ht, m_user_thd, m_prebuilt->trx);
 
@@ -4939,10 +4965,17 @@ static int innobase_init_files(dict_init_mode_t dict_init_mode,
       return innodb_init_abort();
     }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    if (trx_sys->found_prepared_trx() > 0) {
+      ib::error(ER_DD_UPGRADE_FOUND_PREPARED_XA_TRANSACTION);
+      return innodb_init_abort();
+    }
+#else
     if (trx_sys->found_prepared_trx > 0) {
       ib::error(ER_DD_UPGRADE_FOUND_PREPARED_XA_TRANSACTION);
       return innodb_init_abort();
     }
+#endif
 
     /* Disable AHI when we start loading tables for purge.
     These tables are evicted anyway after purge. */
@@ -5185,7 +5218,11 @@ static int innobase_start_trx_and_assign_read_view(
       innobase_map_isolation_level(thd_get_trx_isolation(thd));
 
   if (trx->isolation_level == TRX_ISO_REPEATABLE_READ) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx->read_view.open(trx);
+#else
     trx_assign_read_view(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   } else {
     push_warning_printf(thd, Sql_condition::SL_WARNING, HA_ERR_UNSUPPORTED,
                         "InnoDB: WITH CONSISTENT SNAPSHOT"
@@ -10091,7 +10128,11 @@ int ha_innobase::sample_init(void *&scan_ctx, double sampling_percentage,
   auto trx = m_prebuilt->trx;
   innobase_register_trx(ht, ha_thd(), trx);
   trx_start_if_not_started_xa(trx, false);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx->read_view.open(trx);
+#else
   trx_assign_read_view(trx);
+#endif
 
   /* Parallel read is not currently supported for sampling. */
   size_t n_threads = 1;
@@ -17774,7 +17815,10 @@ int ha_innobase::external_lock(THD *thd, /*!< in: handle to the user thread */
         trx->is_dd_trx here */
         ut_d(trx->is_dd_trx = false);
       }
-
+#ifdef HAVE_LOCK_FREE_READVIEW
+    } else if (trx->isolation_level <= TRX_ISO_READ_COMMITTED) {
+      trx->read_view.close();
+#else
     } else if (trx->isolation_level <= TRX_ISO_READ_COMMITTED &&
                MVCC::is_view_active(trx->read_view)) {
       mutex_enter(&trx_sys->mutex);
@@ -17782,6 +17826,7 @@ int ha_innobase::external_lock(THD *thd, /*!< in: handle to the user thread */
       trx_sys->mvcc->view_close(trx->read_view, true);
 
       mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     }
   }
 
@@ -18377,6 +18422,14 @@ THR_LOCK_DATA **ha_innobase::store_lock(
     trx->isolation_level =
         innobase_map_isolation_level((enum_tx_isolation)thd_tx_isolation(thd));
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    if (trx->isolation_level <= TRX_ISO_READ_COMMITTED) {
+      /* At low transaction isolation levels we let
+      each consistent read set its own snapshot */
+
+      trx->read_view.close();
+    }
+#else
     if (trx->isolation_level <= TRX_ISO_READ_COMMITTED &&
         MVCC::is_view_active(trx->read_view)) {
       /* At low transaction isolation levels we let
@@ -18388,6 +18441,7 @@ THR_LOCK_DATA **ha_innobase::store_lock(
 
       mutex_exit(&trx_sys->mutex);
     }
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 
   DBUG_ASSERT(EQ_CURRENT_THD(thd));
diff --git a/storage/innobase/handler/ha_innopart.cc b/storage/innobase/handler/ha_innopart.cc
index e684f4e..ffa06b7 100644
--- a/storage/innobase/handler/ha_innopart.cc
+++ b/storage/innobase/handler/ha_innopart.cc
@@ -2031,7 +2031,11 @@ int ha_innopart::sample_init(void *&scan_ctx, double sampling_percentage,
   auto trx = m_prebuilt->trx;
   innobase_register_trx(ht, ha_thd(), trx);
   trx_start_if_not_started_xa(trx, false);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx->read_view.open(trx);
+#else
   trx_assign_read_view(trx);
+#endif
 
   /* Parallel read is not currently supported for sampling. */
   size_t n_threads = 1;
@@ -3178,7 +3182,11 @@ int ha_innopart::records(ha_rows *num_rows) {
       trx->mysql_n_tables_locked == 0 && !m_prebuilt->ins_sel_stmt &&
       n_threads > 1) {
     trx_start_if_not_started_xa(trx, false);
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx->read_view.open(trx);
+#else
     trx_assign_read_view(trx);
+#endif
 
     const auto first_used_partition = m_part_info->get_first_used_partition();
 
